﻿using System;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Diagrams.Features;


namespace RadDiagWebinar
{
    public partial class Serialization : UserControl
    {
        public FileManager fileManager;

        public Serialization()
        {
            InitializeComponent();

            fileManager = new FileManager(this.diagram);

            diagram.AddShape("qmsldkf", ShapeFactory.GetShapeGeometry(CommonShapeType.PentagonShape), new Point(120, 120));

            var saveBinding = new CommandBinding(DiagramCommands.Save, CommandBinding_Executed_Save);
            var openBinding = new CommandBinding(DiagramCommands.Open, CommandBinding_Executed_Open);
            CommandManager.RegisterClassCommandBinding(typeof(Serialization), saveBinding);
            CommandManager.RegisterClassCommandBinding(typeof(Serialization), openBinding);
        }

        private static void CommandBinding_Executed_Save(object sender, ExecutedRoutedEventArgs e)
        {
            if (sender == null) throw new ArgumentNullException("sender");
            var owner = sender as Serialization;
            if (owner != null)
            {
                // force a dialog, otherwise we need to leverage the app with elevated trust

                owner.fileManager.CurrentFile = null;
                owner.fileManager.SaveToFile();

                // you can also use the iso; 
                //owner.fileManager.SaveToFile(FileManager.FileLocation.IsolatedStorage);

            }
        }

        private static void CommandBinding_Executed_Open(object sender, ExecutedRoutedEventArgs e)
        {
            if (sender == null) throw new ArgumentNullException("sender");
            var owner = sender as Serialization;
            if (owner != null)
            {
                // force a dialog, otherwise we need to leverage the app with elevated trust
                owner.fileManager.CurrentFile = null;
                owner.fileManager.LoadFromFile();

                /*	 you can also use the iso;
                owner.fileManager.LoadFromFile(FileManager.FileLocation.IsolatedStorage); */

            }
        }


    }
}
